Subject: Re: FVWM: WindowList: immediatly at second entry

From: Mikhael Goikhman <[email-masked]>
Date: Fri, 12 Oct 2001 14:39:00 +0000

On 15 Sep 2001 13:06:49 +0200, Dominik Vogt wrote:
> 
> On Sat, Sep 15, 2001 at 03:36:19AM -0700, Erik Steffl wrote:
> > Dominik Vogt wrote:
> > ...
> > > Gee, since we all hate windows and think that Alt-Tabbing sucks
> > > anyway I guess nobody ever tested Alt-Tab emulation thorough
> > > enough to notice its a bit inconvenient ;-)
> > > 
> > > I have written a patch that adds the new option "ReverseOrder" to
> > > the WindowList command.  If you use it, the pointer will start
> > > over the next list entry and hitting Alt-Tab repeatedly (releasing
> > > the Alt in between) rotates through all the windows instead of
> > > just switching back and forth between the last two.
> > 
> >   seems like a good idea but IMO the name is confusing (I don't even
> > know why you have chosen it). Since it's new code, can you change it to
> > something closer to what it does (StartAtSecond, HighlightSecondItem,
> > MSWinComaptibilityMode or something...)
> 
> I have given it this name because this is exactly what it does: it
> reverses the order of the menu entries.  Without this option, the
> window list is ordered like this:
> 
>   Title
>   Window 1 (window with the focus)
>   Window 2 (window that had the focus before window 1)
>   Window 3 (window that had the focus before window 2)
>   ...
>   Window n (window that had the focus before window n-1)
> 
> and with ReverseOrder:
> 
>   Title
>   Window n (window that had the focus before window n-1)
>   ...
>   Window 3 (window that had the focus before window 2)
>   Window 2 (window that had the focus before window 1)
>   Window 1 (window with the focus)
> 
> The pointer alsways starts ofer the first menu entry.

Dominik, do you think a new ReverseOrder option is useful in any real
situation? It seems too unintuitive for me. And making it a default
for Alt-Tab is more than questionable. At least the previous default
(without ReverseOrder) was totally intuitive.

I think the original request was to preserve the correct window
order, but start over the second menu entry. I.e. with this new
hypotetical option StartAtSecond the menu is:

  Title
  Window 1 (window with the focus)
  Window 2 (window that had the focus before window 1)
  Window 3 (window that had the focus before window 2)
  ...
  Window n (window that had the focus before window n-1)

But the first Alt-Tab points to the Window 2, the next Tab press points
to Window 3 and so on. This would mean enhancements to a menu code.

I want to restore the previous default for Alt-Tab, without ReverseOrder.

Regards,
Mikhael.
--
Visit the official FVWM web page at <URL: http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].

---

From: Dominik Vogt <[email-masked]>
Date: Sun, 14 Oct 2001 22:01:01 +0200

> (without ReverseOrder) was totally intuitive.

Actually, I found the old behaviour totally unintuitive and the
new one much better.  Not that I care much about that, I only
thought it was closer to that M$ stuff.
 
> order, but start over the second menu entry.

The old behaviour looked backwards through the window list.  You
could not walk through the list by pressing Alt-Tab repeatedly.
Instead, focus was toggled between the current window and the last
one that had the focus.

> I.e. with this new

Yes.  I find this very confusing because the order of windows gets
messed up each time I press Alt-Tab.  The idea of the new code was
this:  If I have some windows, then I can always switch from
window A to window B by pressing Alt-Tab, say, n times.  It does
not matter if window C had the focus in between or D, E and F...

> I want to restore the previous default for Alt-Tab, without ReverseOrder.

In the end, I really don't care.  Do whatever you think is the
most nice and intuitive Alt-Tab behaviour.

Bye

Dominik ^_^  ^_^

 --
Dominik Vogt, [email-masked]
Reply-To: [email-masked]
--
Visit the official FVWM web page at <URL: http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].

---

From: Erik Steffl <[email-masked]>
Date: Sun, 14 Oct 2001 18:15:27 -0700

...
> not matter if window C had the focus in between or D, E and F...

  IMO it would be nice if this were configurable: I like the windows to
be ordered in the order they were last visited, e.g. the current window
is on top, the window focused before is second etc...

  that way the most used windows are on the top of the list (I usually
actively use only few windows), the most used windows are easiest to
access.

  this is how ms win alt-tab works and it's one of the few things I like
in ms win and would like to be able to configure fvwm to work exactly
the same way...

  it would be nice to have an option of static list or dynamic list
('recentness' list). Including being able to filter list but I think
that works already (in 2.4, I haven't got around to play with 2.4 config
yet).

	erik

---

From: Mikhael Goikhman <[email-masked]>
Date: Mon, 15 Oct 2001 13:30:08 +0000

> Instead, focus was toggled between the current window and the last

An additional Alt-Tab was the only difference from that MS stuff.
ReverseOrder didn't make it closer at all. It allows to walk through the
list by pressing a single Alt-Tab, but has a side effect that I called
unintuitive, it starts from the oldest visited window instead of the
most recent one.

I myself prefer the default in 2.4.0 over the MS stuff, i.e. it's ok that
the first Alt-Tab points to the already focused window not to the second
one, but I don't care as long as the list is recent-first (not reversed).

> messed up each time I press Alt-Tab.

The chosen window jumps to the top of the list. With ReverseOrder the list
is reversed, so it jumps to the bottom, there is the same logical "mess".

> The idea of the new code was

This may be used for switching between 2 applications, but there are
better solutions IMO for this than WindowList, for example:

  Key 1 A C Current SetEnv WID1 $$w
  Key 1 A M WindowListFunc $$[WID1]
  Key 2 A C Current SetEnv WID2 $$w
  Key 2 A M WindowListFunc $$[WID2]

No need to count or see a list of unrelevant windows, just one press to
bookmark a window and another to switch to it from anywhere.

Regards,
Mikhael.